#include <iostream>

/* Trochę teorii...
 * Funkcje to są fragmenty programu (albo, jak ktoś woli, takie "małe programy"),
 * którym nadajemy nazwę i których używamy ("wywołujemy" / invoke) w innym miejscu.
 * Używając funkcji możemy nadać programom ładną strukturę, podzielić je na logiczne części...
 * Profesjonalne programowanie polega właśnie głównie na tworzeniu funkcji.
 * (Pojęcia bliskoznaczne, które też możecie casem usłyszeć: procedura, metoda, podprogram)

 * Definicja funkcji w C i C++ wygląda tak:
 TYP_WYNIKU NAZWA_FUNKCJI(PARAMETRY) {
    TREŚĆ FUNKCJI / INSTRUKCJE;
 }

 Jeśli funkcja "zwraca wynik" (za pomocą return), to TYPEM_WYNIKU jest
 int, double, std::string lub każdy inny normalny typ.
 Jeśli funkcja nie zwraca wyniku, to jej TYPEM_WYNIKU jest void.
*/

/* Funkcja typu void, czyli po prostu zapamiętany fragment kodu: */
void aaa() {
    std::cout << "Aaa, kotki dwa\n";
    std::cout << "Szarobure obydwa\n";
}

/* Samo zdefiniowanie funkcji jeszcze jej nie uruchamia.
 * Trzeba ją wywołać (bezpośrednio albo pośrednio) w main - zobaczysz to poniżej.
 */

/* Funkcja z parametrami: */
void wypisz(std::string napis, int ile_razy) {
    for(int i = 0; i < ile_razy; i++) {
        std::cout << napis << '\n';
    }
}

/* Funkcje zwracające wynik: */
int ostatnia_cyfra(int liczba) {
    return liczba % 10;
}

/* main też jest funkcją, ale taką specjalną,
 * która jest automatycznie wywoływana, gdy uruchamiamy program. */
int main()
{
    std::cout << "Początek main\n";
    std::cout << "Kołysanka 2 razy:\n";

    // wywołanie funkcji - zwróć uwagę na nawiasy - są potrzebne nawet gdy nie ma parametrów
    aaa();
    aaa();
    std::cout << "\nZaraz coś wypiszemy\n";

    // wywołania z parametrami:
    wypisz("Ala ma kota", 5);
    wypisz("Ola ma psa", 2);

    std::cout << "\nTeraz wywołam ostatnia_cyfra(13)...\n";
    // Uwaga - samo wywołanie funkcji jeszcze nie wyświetla jej wyniku!
    ostatnia_cyfra(13);

    // Wynik trzeba "odebrać", np. zapisać go do zmiennej.
    std::cout << "Teraz wywołam ostatnia_cyfra(17) i odbiorę wynik...\n";
    int wynik;
    wynik = ostatnia_cyfra(17);
    std::cout << "OK, ostatnią cyfrą jest " << wynik << '\n';
    std::cout << "\nTeraz wywołam ostatnia_cyfra(144) i odbiorę wynik...\n";
    wynik = ostatnia_cyfra(144);
    std::cout << "OK, ostatnią cyfrą jest " << wynik << '\n';

    // Można też bezpośrednio wypisać wynik funkcji bez użycia zmiennej.
    std::cout << "A teraz bezpośrednio tu: " << ostatnia_cyfra(351) << '\n';

    std::cout << "Koniec main\n";
    return 0;
}
